package MIDICompose;

public class Note extends MIDIObject implements Channelable, Lengthable, Pitchable
{
	public Note(int length, int pitch) { this(length, pitch, MIDIVariables.MEDIUM); }
	public Note(int length, int pitch, int velocity) {
		this(0, 0, length, pitch, velocity, velocity); }
	public Note(int deltaTime, int channel, int length, int pitch, int velocity, int offVelocity) {
		super(deltaTime);
		add(new NoteOn(0, channel, pitch, velocity));
		add(new NoteOff(length, channel, pitch, offVelocity));
		lock(); }

	public int channel() { return ((NoteOn)elementAt(0)).channel(); }
	public void setChannel(int channel) {				// sets Channel of the note
		((NoteOn)elementAt(0)).setChannel(channel);
		((NoteOff)elementAt(1)).setChannel(channel); }

	public int pitch() { return ((NoteOn)elementAt(0)).pitch(); }
	public void setPitch(int pitch) {						// sets Pitch of the note
		((NoteOn)elementAt(0)).setPitch(pitch);
		((NoteOff)elementAt(1)).setPitch(pitch); }

	public int velocity() { return ((NoteOn)elementAt(0)).velocity(); }
	public void setVelocity(int velocity) {			// sets Velocity of the note
		((NoteOn)elementAt(0)).setVelocity(velocity); }

	public int offVelocity() { return ((NoteOff)elementAt(1)).velocity(); }
	public void setOffVelocity(int offVelocity) {
		((NoteOff)elementAt(1)).setVelocity(offVelocity); }

	public int length() { return ((NoteOff)elementAt(1)).deltaTime(); }
	public void setLength(int length) {
		((NoteOff)elementAt(1)).setDeltaTime(length); }
	public void turnRound() { return; }					// a turned round note is the same note

	public MIDIObject copy() {
		return new Note(deltaTime(), channel(), length(), pitch(), velocity(), offVelocity()); }
}
